import React, { Component } from 'react';
import { Tabs } from 'antd';
import Modal from '@/components/common/Modal';
import NewOrder from './NewOrder';

const { TabPane } = Tabs;

class TableModal extends Component{
  constructor(props) {
    super(props);
    this.state={
      activeKey: props.defaultActiveKey || '1'
    }
  }

  render() {
    return (
     <>
       <Modal
         {...this.props}
         footer={null}
       >
         <Tabs
           defaultActiveKey={this.props.defaultActiveKey || '1'}
           activeKey={this.state.activeKey}
           onChange={(key)=>this.setState({activeKey: key})}>
           <TabPane tab="最新订单" key="1">
            <NewOrder {...this.props}/>
           </TabPane>
           <TabPane tab="合同变更发起" key="2">
             Content of Tab Pane 2
           </TabPane>
         </Tabs>
       </Modal>
       </>
    );
  }
}

export default TableModal;
