import {
  processStatus,
  liquidationStatus,
  approvedState,
  newOrderStatus,
  invoiceStatus
} from './dataDic';

// 流程状态
const getProcessStatus =(e) => {
  if (e || e === 0) {
    let theType = "";
    processStatus.forEach((item) => {
      if (item.value === e.toString()) {
        theType = item.key;
      }
    });
    return theType;
  }
  return '';
}

// 结算状态
const getLiquidationStatus = (e) => {
  if (e || e === 0) {
    let theType = "";
    liquidationStatus.forEach((item) => {
      if (item.value === e.toString()) {
        theType = item.key;
      }
    });
    return theType;
  }
  return '';
}

// 特批状态
const getApprovedState = (e) => {
  if (e || e === 0) {
    let theType = "";
    approvedState.forEach((item) => {
      if (item.value === e.toString()) {
        theType = item.key;
      }
    });
    return theType;
  }
  return '';
}

// 订单状态
const getNewOrderStatus = (e) => {
  if (e || e === 0) {
    let theType = "";
    newOrderStatus.forEach((item) => {
      if (item.value === e.toString()) {
        theType = item.key;
      }
    });
    return theType;
  }
  return '';
}

// 开票状态
const getInvoiceStatus = (e, record) => {
  if (record && record.approval === 1) {
    return "特批待审核";
  }else{
    if (e || e === 0) {
      let theType = "";
      invoiceStatus.forEach((item) => {
        if (item.value === e.toString()) {
          theType = item.key;
        }
      });
      return theType;
    }
  }
}

export {
  getProcessStatus,
  getLiquidationStatus,
  getApprovedState,
  getNewOrderStatus,
  getInvoiceStatus,
};
